# vmware_tag_manager – Manage association of VMware tags with VMware objects

New in version 2.8.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- This module can be used to assign / remove VMware tags from the given VMware objects.

- Tag feature is introduced in vSphere 6 version, so this module is not supported in the earlier versions of vSphere.

- All variables and VMware object names are case sensitive.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6

- PyVmomi

- vSphere Automation SDK

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
hostname string |  | The hostname or IP address of the vSphere vCenter server. If the value is not specified in the task, the value of environment variable `VMWARE_HOST` will be used instead.
object_name string / required |  | Name of the object to work with. For DistributedVirtualPortgroups the format should be "switch_name:portgroup_name"

object_type
string / required

Choices:
- VirtualMachine
- Datacenter
- ClusterComputeResource
- HostSystem
- DistributedVirtualSwitch
- DistributedVirtualPortgroup

Type of object to work with.

password string |  | The password of the vSphere vCenter server. If the value is not specified in the task, the value of environment variable `VMWARE_PASSWORD` will be used instead. aliases: pass, pwd

protocol
string

Choices:
- http
- https ←

The connection to protocol.

state
string

Choices:
- present
- absent
- add ←
- remove
- set

If `state` is set to `add` or `present` will add the tags to the existing tag list of the given object.
If `state` is set to `remove` or `absent` will remove the tags from the existing tag list of the given object.
If `state` is set to `set` will replace the tags of the given objects with the user defined list of tags.

tag_names list / required |  | List of tag(s) to be managed. You can also specify category name by specifying colon separated value. For example, "category_name:tag_name". You can skip category name if you have unique tag names.
username string |  | The username of the vSphere vCenter server. If the value is not specified in the task, the value of environment variable `VMWARE_USER` will be used instead. aliases: admin, user

validate_certs
boolean

Choices:
- no
- yes ←

Allows connection when SSL certificates are not valid.
Set to `no` when certificates are not trusted.
If the value is not specified in the task, the value of environment variable `VMWARE_VALIDATE_CERTS` will be used instead.

## Notes

Note

- Tested on vSphere 6.5

## Examples

    - name: Add tags to a virtual machine
      vmware_tag_manager:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        validate_certs: no
        tag_names:
          - Sample_Tag_0002
          - Category_0001:Sample_Tag_0003
        object_name: Fedora_VM
        object_type: VirtualMachine
        state: add
      delegate_to: localhost

    - name: Remove a tag from a virtual machine
      vmware_tag_manager:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        validate_certs: no
        tag_names:
          - Sample_Tag_0002
        object_name: Fedora_VM
        object_type: VirtualMachine
        state: remove
      delegate_to: localhost

    - name: Add tags to a distributed virtual switch
      vmware_tag_manager:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        validate_certs: no
        tag_names:
          - Sample_Tag_0003
        object_name: Switch_0001
        object_type: DistributedVirtualSwitch
        state: add
      delegate_to: localhost

    - name: Add tags to a distributed virtual portgroup
      vmware_tag_manager:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        validate_certs: no
        tag_names:
          - Sample_Tag_0004
        object_name: Switch_0001:Portgroup_0001
        object_type: DistributedVirtualPortgroup
        state: add
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
tag_status list | on success | metadata about tags related to object configuration Sample: {'current_tags': ['backup', 'security'], 'desired_tags': ['security'], 'previous_tags': ['backup', 'security']}

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Abhijeet Kasurde (@Akasurde)

- Frederic Van Reet (@GBrawl)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.